{-# OPTIONS -fglasgow-exts -cpp #-}
{- 
   CodeGen.y  by Akimasa Morihata

   Parser for Optimal Path Query System (Happy File) 

   You can use two atomic predicates "from" and "to": 
       from(e,v)  =  in(e) == v
       to(e,v)  =  out(e) == v
   In addition, you can use an atomic predicate "train", 
   which is practically nonsense:
       train(e) == odd(in(e)) && odd(out(e)) 
   You can use a weight function "w".
-}

module Main where
import CodeGenMain
import Data.Char
import System.IO
import System
import Debug.Trace
#if __GLASGOW_HASKELL__ >= 503
import Data.Array
#else
import Array
#endif
#if __GLASGOW_HASKELL__ >= 503
import GHC.Exts
#else
import GlaExts
#endif

-- parser produced by Happy Version 1.16

newtype HappyAbsSyn t4 t5 t6 t7 t8 t9 t10 t11 t12 t13 t14 t15 = HappyAbsSyn (() -> ())
happyIn4 :: t4 -> (HappyAbsSyn t4 t5 t6 t7 t8 t9 t10 t11 t12 t13 t14 t15)
happyIn4 x = unsafeCoerce# x
{-# INLINE happyIn4 #-}
happyOut4 :: (HappyAbsSyn t4 t5 t6 t7 t8 t9 t10 t11 t12 t13 t14 t15) -> t4
happyOut4 x = unsafeCoerce# x
{-# INLINE happyOut4 #-}
happyIn5 :: t5 -> (HappyAbsSyn t4 t5 t6 t7 t8 t9 t10 t11 t12 t13 t14 t15)
happyIn5 x = unsafeCoerce# x
{-# INLINE happyIn5 #-}
happyOut5 :: (HappyAbsSyn t4 t5 t6 t7 t8 t9 t10 t11 t12 t13 t14 t15) -> t5
happyOut5 x = unsafeCoerce# x
{-# INLINE happyOut5 #-}
happyIn6 :: t6 -> (HappyAbsSyn t4 t5 t6 t7 t8 t9 t10 t11 t12 t13 t14 t15)
happyIn6 x = unsafeCoerce# x
{-# INLINE happyIn6 #-}
happyOut6 :: (HappyAbsSyn t4 t5 t6 t7 t8 t9 t10 t11 t12 t13 t14 t15) -> t6
happyOut6 x = unsafeCoerce# x
{-# INLINE happyOut6 #-}
happyIn7 :: t7 -> (HappyAbsSyn t4 t5 t6 t7 t8 t9 t10 t11 t12 t13 t14 t15)
happyIn7 x = unsafeCoerce# x
{-# INLINE happyIn7 #-}
happyOut7 :: (HappyAbsSyn t4 t5 t6 t7 t8 t9 t10 t11 t12 t13 t14 t15) -> t7
happyOut7 x = unsafeCoerce# x
{-# INLINE happyOut7 #-}
happyIn8 :: t8 -> (HappyAbsSyn t4 t5 t6 t7 t8 t9 t10 t11 t12 t13 t14 t15)
happyIn8 x = unsafeCoerce# x
{-# INLINE happyIn8 #-}
happyOut8 :: (HappyAbsSyn t4 t5 t6 t7 t8 t9 t10 t11 t12 t13 t14 t15) -> t8
happyOut8 x = unsafeCoerce# x
{-# INLINE happyOut8 #-}
happyIn9 :: t9 -> (HappyAbsSyn t4 t5 t6 t7 t8 t9 t10 t11 t12 t13 t14 t15)
happyIn9 x = unsafeCoerce# x
{-# INLINE happyIn9 #-}
happyOut9 :: (HappyAbsSyn t4 t5 t6 t7 t8 t9 t10 t11 t12 t13 t14 t15) -> t9
happyOut9 x = unsafeCoerce# x
{-# INLINE happyOut9 #-}
happyIn10 :: t10 -> (HappyAbsSyn t4 t5 t6 t7 t8 t9 t10 t11 t12 t13 t14 t15)
happyIn10 x = unsafeCoerce# x
{-# INLINE happyIn10 #-}
happyOut10 :: (HappyAbsSyn t4 t5 t6 t7 t8 t9 t10 t11 t12 t13 t14 t15) -> t10
happyOut10 x = unsafeCoerce# x
{-# INLINE happyOut10 #-}
happyIn11 :: t11 -> (HappyAbsSyn t4 t5 t6 t7 t8 t9 t10 t11 t12 t13 t14 t15)
happyIn11 x = unsafeCoerce# x
{-# INLINE happyIn11 #-}
happyOut11 :: (HappyAbsSyn t4 t5 t6 t7 t8 t9 t10 t11 t12 t13 t14 t15) -> t11
happyOut11 x = unsafeCoerce# x
{-# INLINE happyOut11 #-}
happyIn12 :: t12 -> (HappyAbsSyn t4 t5 t6 t7 t8 t9 t10 t11 t12 t13 t14 t15)
happyIn12 x = unsafeCoerce# x
{-# INLINE happyIn12 #-}
happyOut12 :: (HappyAbsSyn t4 t5 t6 t7 t8 t9 t10 t11 t12 t13 t14 t15) -> t12
happyOut12 x = unsafeCoerce# x
{-# INLINE happyOut12 #-}
happyIn13 :: t13 -> (HappyAbsSyn t4 t5 t6 t7 t8 t9 t10 t11 t12 t13 t14 t15)
happyIn13 x = unsafeCoerce# x
{-# INLINE happyIn13 #-}
happyOut13 :: (HappyAbsSyn t4 t5 t6 t7 t8 t9 t10 t11 t12 t13 t14 t15) -> t13
happyOut13 x = unsafeCoerce# x
{-# INLINE happyOut13 #-}
happyIn14 :: t14 -> (HappyAbsSyn t4 t5 t6 t7 t8 t9 t10 t11 t12 t13 t14 t15)
happyIn14 x = unsafeCoerce# x
{-# INLINE happyIn14 #-}
happyOut14 :: (HappyAbsSyn t4 t5 t6 t7 t8 t9 t10 t11 t12 t13 t14 t15) -> t14
happyOut14 x = unsafeCoerce# x
{-# INLINE happyOut14 #-}
happyIn15 :: t15 -> (HappyAbsSyn t4 t5 t6 t7 t8 t9 t10 t11 t12 t13 t14 t15)
happyIn15 x = unsafeCoerce# x
{-# INLINE happyIn15 #-}
happyOut15 :: (HappyAbsSyn t4 t5 t6 t7 t8 t9 t10 t11 t12 t13 t14 t15) -> t15
happyOut15 x = unsafeCoerce# x
{-# INLINE happyOut15 #-}
happyInTok :: Token -> (HappyAbsSyn t4 t5 t6 t7 t8 t9 t10 t11 t12 t13 t14 t15)
happyInTok x = unsafeCoerce# x
{-# INLINE happyInTok #-}
happyOutTok :: (HappyAbsSyn t4 t5 t6 t7 t8 t9 t10 t11 t12 t13 t14 t15) -> Token
happyOutTok x = unsafeCoerce# x
{-# INLINE happyOutTok #-}

happyActOffsets :: HappyAddr
happyActOffsets = HappyA# "\x08\x01\x08\x01\x03\x01\xfe\x00\xfc\x00\x00\x01\xfa\x00\xff\x00\xff\xff\x91\x00\xfd\x00\x00\x00\x00\x00\x80\x00\xfb\x00\xf9\x00\x00\x00\xf6\x00\x00\x00\xff\xff\x00\x00\xff\xff\xf5\x00\xf2\x00\xff\xff\x12\x00\x2c\x00\x01\x00\x01\x00\xfb\xff\x00\x00\xf8\x00\x0d\x00\x0d\x00\x01\x00\x01\x00\x01\x00\x01\x00\x01\x00\xff\xff\xf7\x00\xff\xff\xf3\x00\x00\x00\xf4\x00\xf4\x00\xf0\x00\x00\x00\x00\x00\xef\x00\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\xeb\x00\x00\x00\xc1\x00\x01\x00\xea\x00\xe7\x00\x00\x00\x00\x00\x01\x00\x01\x00\xee\x00\x1c\x00\xed\x00\xe6\x00\xf1\x00\xfd\xff\x00\x00\x00\x00\xe4\x00\xe5\x00\xe0\x00\xdc\x00\x01\x00\xdb\x00\xda\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xff\xff\xec\x00\xd8\x00\x11\x00\x27\x00\xe9\x00\xe8\x00\xdf\x00\xff\xff\xd5\x00\xd2\x00\xe3\x00\xe2\x00\x0c\x00\x0e\x00\xe1\x00\xde\x00\xd0\x00\xcf\x00\xdd\x00\xd9\x00\xce\x00\xcd\x00\xc9\x00\xc8\x00\xc7\x00\xc5\x00\xcc\x00\xcb\x00\x8a\x00\x25\x00\x01\x00\xff\xff\xff\xff\x01\x00\x19\x00\x0b\x00\x09\x00\x03\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00"#

happyGotoOffsets :: HappyAddr
happyGotoOffsets = HappyA# "\x28\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x70\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x83\x00\x00\x00\x68\x00\x00\x00\x00\x00\x60\x00\x00\x00\x00\x00\xc6\x00\xc2\x00\x00\x00\x00\x00\x00\x00\x1b\x00\x37\x00\xbe\x00\xba\x00\xb6\x00\xb2\x00\xae\x00\x7d\x00\xd4\x00\x77\x00\x00\x00\x00\x00\xd1\x00\x94\x00\x00\x00\x00\x00\x00\x00\x00\x00\xaa\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xa6\x00\x00\x00\x00\x00\x00\x00\x00\x00\xa2\x00\x9e\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x9a\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x58\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x50\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x96\x00\x48\x00\x40\x00\x92\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00"#

happyDefActions :: HappyAddr
happyDefActions = HappyA# "\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xf5\xff\xf3\xff\xed\xff\x00\x00\xe6\xff\xe4\xff\xe2\xff\x00\x00\xf2\xff\x00\x00\xe0\xff\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xf1\xff\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xfb\xff\x00\x00\xf6\xff\xfe\xff\xfb\xff\xfb\xff\x00\x00\xf4\xff\xe9\xff\x00\x00\x00\x00\xe8\xff\xeb\xff\xea\xff\xec\xff\xe5\xff\xe3\xff\x00\x00\x00\x00\x00\x00\x00\x00\xdd\xff\xee\xff\x00\x00\x00\x00\x00\x00\xf0\xff\x00\x00\x00\x00\x00\x00\x00\x00\xfc\xff\xfd\xff\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xdf\xff\xde\xff\xe7\xff\xef\xff\xe1\xff\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xf7\xff\xf9\xff\xfa\xff\xf8\xff"#

happyCheck :: HappyAddr
happyCheck = HappyA# "\xff\xff\x04\x00\x07\x00\x04\x00\x05\x00\x04\x00\x0b\x00\x08\x00\x09\x00\x0a\x00\x09\x00\x0a\x00\x0d\x00\x0e\x00\x0d\x00\x0e\x00\x07\x00\x04\x00\x07\x00\x07\x00\x17\x00\x16\x00\x09\x00\x16\x00\x07\x00\x07\x00\x0d\x00\x0e\x00\x19\x00\x0f\x00\x10\x00\x11\x00\x12\x00\x13\x00\x19\x00\x16\x00\x19\x00\x19\x00\x0b\x00\x19\x00\x00\x00\x17\x00\x19\x00\x0f\x00\x10\x00\x11\x00\x12\x00\x13\x00\x14\x00\x15\x00\x19\x00\x17\x00\x0f\x00\x19\x00\x0f\x00\x10\x00\x11\x00\x12\x00\x13\x00\x0f\x00\x10\x00\x11\x00\x12\x00\x13\x00\x19\x00\x0a\x00\x0b\x00\x17\x00\x04\x00\x05\x00\x06\x00\x07\x00\x08\x00\x09\x00\x0a\x00\x0b\x00\x04\x00\x05\x00\x06\x00\x07\x00\x08\x00\x09\x00\x0a\x00\x0b\x00\x04\x00\x05\x00\x06\x00\x07\x00\x08\x00\x09\x00\x0a\x00\x0b\x00\x04\x00\x05\x00\x06\x00\x07\x00\x08\x00\x09\x00\x0a\x00\x0b\x00\x04\x00\x05\x00\x06\x00\x07\x00\x08\x00\x09\x00\x0a\x00\x0b\x00\x04\x00\x05\x00\x06\x00\x07\x00\x08\x00\x09\x00\x0a\x00\x0b\x00\x04\x00\x05\x00\x06\x00\x07\x00\x08\x00\x09\x00\x0a\x00\x0b\x00\x05\x00\x06\x00\x07\x00\x08\x00\x09\x00\x0a\x00\x0b\x00\x06\x00\x07\x00\x08\x00\x09\x00\x0a\x00\x0b\x00\x06\x00\x07\x00\x08\x00\x09\x00\x0a\x00\x0b\x00\x0f\x00\x10\x00\x11\x00\x12\x00\x13\x00\x03\x00\x01\x00\x02\x00\x03\x00\x07\x00\x0f\x00\x08\x00\x09\x00\x0a\x00\x0b\x00\x08\x00\x09\x00\x0a\x00\x0b\x00\x08\x00\x09\x00\x0a\x00\x0b\x00\x08\x00\x09\x00\x0a\x00\x0b\x00\x08\x00\x09\x00\x0a\x00\x0b\x00\x08\x00\x09\x00\x0a\x00\x0b\x00\x08\x00\x09\x00\x0a\x00\x0b\x00\x08\x00\x09\x00\x0a\x00\x0b\x00\x08\x00\x09\x00\x0a\x00\x0b\x00\x08\x00\x09\x00\x0a\x00\x0b\x00\x08\x00\x09\x00\x0a\x00\x0b\x00\x08\x00\x09\x00\x0a\x00\x0b\x00\x08\x00\x09\x00\x0a\x00\x0b\x00\x08\x00\x09\x00\x0a\x00\x0b\x00\x01\x00\x02\x00\x03\x00\x01\x00\x02\x00\x03\x00\x17\x00\x18\x00\x0f\x00\x0f\x00\x17\x00\x04\x00\x17\x00\x17\x00\x17\x00\x04\x00\x04\x00\x16\x00\x16\x00\x04\x00\x04\x00\x04\x00\x16\x00\x1a\x00\x1a\x00\x16\x00\x04\x00\x04\x00\x0f\x00\x17\x00\x04\x00\x17\x00\x17\x00\x17\x00\x0f\x00\x04\x00\x09\x00\x17\x00\x04\x00\x06\x00\x0c\x00\x04\x00\x04\x00\x17\x00\x1a\x00\x18\x00\x15\x00\x02\x00\x18\x00\x06\x00\x04\x00\x16\x00\x16\x00\x04\x00\x16\x00\x01\x00\xff\xff\x16\x00\x16\x00\xff\xff\x15\x00\x14\x00\xff\xff\x17\x00\x16\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\x1b\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff"#

happyTable :: HappyAddr
happyTable = HappyA# "\x00\x00\x4a\x00\x2a\x00\x12\x00\x13\x00\x32\x00\x3b\x00\x14\x00\x15\x00\x16\x00\x15\x00\x16\x00\x17\x00\x18\x00\x17\x00\x18\x00\x2a\x00\x32\x00\x2a\x00\x2a\x00\x4b\x00\x19\x00\x15\x00\x33\x00\x2a\x00\x2a\x00\x17\x00\x18\x00\x7d\x00\x23\x00\x24\x00\x25\x00\x26\x00\x27\x00\x7e\x00\x33\x00\x7f\x00\x66\x00\x38\x00\x65\x00\x03\x00\x3f\x00\x5c\x00\xe1\xff\xe1\xff\xe1\xff\xe1\xff\xe1\xff\xe1\xff\xe1\xff\x80\x00\xe1\xff\x75\x00\xe1\xff\x23\x00\x24\x00\x25\x00\x26\x00\x27\x00\x23\x00\x24\x00\x25\x00\x26\x00\x27\x00\x5b\x00\x37\x00\x10\x00\x3e\x00\x79\x00\x0a\x00\x0b\x00\x0c\x00\x0d\x00\x0e\x00\x0f\x00\x10\x00\x7a\x00\x0a\x00\x0b\x00\x0c\x00\x0d\x00\x0e\x00\x0f\x00\x10\x00\x62\x00\x0a\x00\x0b\x00\x0c\x00\x63\x00\x0e\x00\x0f\x00\x10\x00\x58\x00\x0a\x00\x0b\x00\x0c\x00\x59\x00\x0e\x00\x0f\x00\x10\x00\x19\x00\x0a\x00\x0b\x00\x0c\x00\x1a\x00\x0e\x00\x0f\x00\x10\x00\x1d\x00\x0a\x00\x0b\x00\x0c\x00\x0d\x00\x0e\x00\x0f\x00\x10\x00\x09\x00\x0a\x00\x0b\x00\x0c\x00\x0d\x00\x0e\x00\x0f\x00\x10\x00\x2a\x00\x0b\x00\x0c\x00\x0d\x00\x0e\x00\x0f\x00\x10\x00\x2f\x00\x0c\x00\x0d\x00\x0e\x00\x0f\x00\x10\x00\x1e\x00\x0c\x00\x0d\x00\x0e\x00\x0f\x00\x10\x00\x23\x00\x24\x00\x25\x00\x26\x00\x27\x00\x29\x00\x47\x00\x2c\x00\x2d\x00\x2a\x00\x76\x00\x78\x00\x0e\x00\x0f\x00\x10\x00\x7b\x00\x0e\x00\x0f\x00\x10\x00\x52\x00\x0e\x00\x0f\x00\x10\x00\x4e\x00\x0e\x00\x0f\x00\x10\x00\x4f\x00\x0e\x00\x0f\x00\x10\x00\x41\x00\x0e\x00\x0f\x00\x10\x00\x44\x00\x0e\x00\x0f\x00\x10\x00\x30\x00\x0e\x00\x0f\x00\x10\x00\x33\x00\x0e\x00\x0f\x00\x10\x00\x34\x00\x0e\x00\x0f\x00\x10\x00\x35\x00\x0e\x00\x0f\x00\x10\x00\x36\x00\x0e\x00\x0f\x00\x10\x00\x3b\x00\x0e\x00\x0f\x00\x10\x00\x3c\x00\x0e\x00\x0f\x00\x10\x00\x48\x00\x2c\x00\x2d\x00\x2b\x00\x2c\x00\x2d\x00\x43\x00\x44\x00\x77\x00\x78\x00\x71\x00\x6f\x00\x72\x00\x73\x00\x74\x00\x70\x00\x6b\x00\x6d\x00\x6e\x00\x6c\x00\x67\x00\x68\x00\x61\x00\x69\x00\x6a\x00\x62\x00\x5f\x00\x60\x00\x5e\x00\x5d\x00\x58\x00\x51\x00\x52\x00\x54\x00\x56\x00\x4c\x00\x4d\x00\x55\x00\x2f\x00\x28\x00\x4e\x00\x2f\x00\x3a\x00\x3e\x00\x57\x00\x40\x00\x21\x00\x09\x00\x41\x00\x28\x00\x07\x00\x46\x00\x47\x00\x05\x00\x1c\x00\x03\x00\x00\x00\x1d\x00\x20\x00\x00\x00\x21\x00\x22\x00\x00\x00\x08\x00\x06\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xff\xff\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00"#

happyReduceArr = array (1, 34) [
	(1 , happyReduce_1),
	(2 , happyReduce_2),
	(3 , happyReduce_3),
	(4 , happyReduce_4),
	(5 , happyReduce_5),
	(6 , happyReduce_6),
	(7 , happyReduce_7),
	(8 , happyReduce_8),
	(9 , happyReduce_9),
	(10 , happyReduce_10),
	(11 , happyReduce_11),
	(12 , happyReduce_12),
	(13 , happyReduce_13),
	(14 , happyReduce_14),
	(15 , happyReduce_15),
	(16 , happyReduce_16),
	(17 , happyReduce_17),
	(18 , happyReduce_18),
	(19 , happyReduce_19),
	(20 , happyReduce_20),
	(21 , happyReduce_21),
	(22 , happyReduce_22),
	(23 , happyReduce_23),
	(24 , happyReduce_24),
	(25 , happyReduce_25),
	(26 , happyReduce_26),
	(27 , happyReduce_27),
	(28 , happyReduce_28),
	(29 , happyReduce_29),
	(30 , happyReduce_30),
	(31 , happyReduce_31),
	(32 , happyReduce_32),
	(33 , happyReduce_33),
	(34 , happyReduce_34)
	]

happy_n_terms = 28 :: Int
happy_n_nonterms = 12 :: Int

happyReduce_1 = happyReduce 9# 0# happyReduction_1
happyReduction_1 (happy_x_9 `HappyStk`
	happy_x_8 `HappyStk`
	happy_x_7 `HappyStk`
	happy_x_6 `HappyStk`
	happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOutTok happy_x_2 of { (TokenID happy_var_2) -> 
	case happyOutTok happy_x_4 of { (TokenID happy_var_4) -> 
	case happyOut8 happy_x_7 of { happy_var_7 -> 
	case happyOut5 happy_x_9 of { happy_var_9 -> 
	happyIn4
		 ((happy_var_2,happy_var_7 (happy_var_4,bot ""), happy_var_9)
	) `HappyStk` happyRest}}}}

happyReduce_2 = happySpecReduce_2  1# happyReduction_2
happyReduction_2 happy_x_2
	happy_x_1
	 =  case happyOut6 happy_x_1 of { happy_var_1 -> 
	case happyOut5 happy_x_2 of { happy_var_2 -> 
	happyIn5
		 (happy_var_1 : happy_var_2
	)}}

happyReduce_3 = happySpecReduce_2  1# happyReduction_3
happyReduction_3 happy_x_2
	happy_x_1
	 =  case happyOut7 happy_x_1 of { happy_var_1 -> 
	case happyOut5 happy_x_2 of { happy_var_2 -> 
	happyIn5
		 (happy_var_1 : happy_var_2
	)}}

happyReduce_4 = happySpecReduce_0  1# happyReduction_4
happyReduction_4  =  happyIn5
		 ([]
	)

happyReduce_5 = happyReduce 15# 2# happyReduction_5
happyReduction_5 (happy_x_15 `HappyStk`
	happy_x_14 `HappyStk`
	happy_x_13 `HappyStk`
	happy_x_12 `HappyStk`
	happy_x_11 `HappyStk`
	happy_x_10 `HappyStk`
	happy_x_9 `HappyStk`
	happy_x_8 `HappyStk`
	happy_x_7 `HappyStk`
	happy_x_6 `HappyStk`
	happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOutTok happy_x_1 of { (TokenID happy_var_1) -> 
	case happyOut8 happy_x_5 of { happy_var_5 -> 
	case happyOutTok happy_x_7 of { (TokenID happy_var_7) -> 
	case happyOutTok happy_x_9 of { (TokenID happy_var_9) -> 
	case happyOutTok happy_x_11 of { (TokenID happy_var_11) -> 
	case happyOut8 happy_x_14 of { happy_var_14 -> 
	happyIn6
		 (if happy_var_1 == happy_var_7 
             then BoolFunc happy_var_1 (happy_var_5 (bot "", bot "")) (happy_var_14 (happy_var_9,happy_var_11)) 
             else bot "bfd"
	) `HappyStk` happyRest}}}}}}

happyReduce_6 = happyReduce 15# 2# happyReduction_6
happyReduction_6 (happy_x_15 `HappyStk`
	happy_x_14 `HappyStk`
	happy_x_13 `HappyStk`
	happy_x_12 `HappyStk`
	happy_x_11 `HappyStk`
	happy_x_10 `HappyStk`
	happy_x_9 `HappyStk`
	happy_x_8 `HappyStk`
	happy_x_7 `HappyStk`
	happy_x_6 `HappyStk`
	happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOutTok happy_x_1 of { (TokenID happy_var_1) -> 
	case happyOutTok happy_x_3 of { (TokenID happy_var_3) -> 
	case happyOutTok happy_x_5 of { (TokenID happy_var_5) -> 
	case happyOut8 happy_x_8 of { happy_var_8 -> 
	case happyOutTok happy_x_10 of { (TokenID happy_var_10) -> 
	case happyOut8 happy_x_14 of { happy_var_14 -> 
	happyIn6
		 (if happy_var_1 == happy_var_10 
             then BoolFunc happy_var_1 (happy_var_14 (bot "",bot "")) (happy_var_8 (happy_var_3,happy_var_5))
             else bot "bfd"
	) `HappyStk` happyRest}}}}}}

happyReduce_7 = happyReduce 15# 3# happyReduction_7
happyReduction_7 (happy_x_15 `HappyStk`
	happy_x_14 `HappyStk`
	happy_x_13 `HappyStk`
	happy_x_12 `HappyStk`
	happy_x_11 `HappyStk`
	happy_x_10 `HappyStk`
	happy_x_9 `HappyStk`
	happy_x_8 `HappyStk`
	happy_x_7 `HappyStk`
	happy_x_6 `HappyStk`
	happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOutTok happy_x_1 of { (TokenID happy_var_1) -> 
	case happyOut12 happy_x_5 of { happy_var_5 -> 
	case happyOutTok happy_x_7 of { (TokenID happy_var_7) -> 
	case happyOutTok happy_x_9 of { (TokenID happy_var_9) -> 
	case happyOutTok happy_x_11 of { (TokenID happy_var_11) -> 
	case happyOut12 happy_x_14 of { happy_var_14 -> 
	happyIn7
		 (if happy_var_1 == happy_var_7 
             then IntFunc happy_var_1 (happy_var_5 (bot "", bot "")) (happy_var_14 (happy_var_9,happy_var_11)) 
             else bot "ifd"
	) `HappyStk` happyRest}}}}}}

happyReduce_8 = happyReduce 15# 3# happyReduction_8
happyReduction_8 (happy_x_15 `HappyStk`
	happy_x_14 `HappyStk`
	happy_x_13 `HappyStk`
	happy_x_12 `HappyStk`
	happy_x_11 `HappyStk`
	happy_x_10 `HappyStk`
	happy_x_9 `HappyStk`
	happy_x_8 `HappyStk`
	happy_x_7 `HappyStk`
	happy_x_6 `HappyStk`
	happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOutTok happy_x_1 of { (TokenID happy_var_1) -> 
	case happyOutTok happy_x_3 of { (TokenID happy_var_3) -> 
	case happyOutTok happy_x_5 of { (TokenID happy_var_5) -> 
	case happyOut12 happy_x_8 of { happy_var_8 -> 
	case happyOutTok happy_x_10 of { (TokenID happy_var_10) -> 
	case happyOut12 happy_x_14 of { happy_var_14 -> 
	happyIn7
		 (if happy_var_1 == happy_var_10 
             then IntFunc happy_var_1 (happy_var_14 (bot "",bot "")) (happy_var_8 (happy_var_3,happy_var_5))
             else bot "ifd"
	) `HappyStk` happyRest}}}}}}

happyReduce_9 = happySpecReduce_3  4# happyReduction_9
happyReduction_9 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut8 happy_x_1 of { happy_var_1 -> 
	case happyOut9 happy_x_3 of { happy_var_3 -> 
	happyIn8
		 (\p -> (happy_var_1 p) :|: (happy_var_3 p)
	)}}

happyReduce_10 = happySpecReduce_1  4# happyReduction_10
happyReduction_10 happy_x_1
	 =  case happyOut9 happy_x_1 of { happy_var_1 -> 
	happyIn8
		 (happy_var_1
	)}

happyReduce_11 = happySpecReduce_3  5# happyReduction_11
happyReduction_11 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut9 happy_x_1 of { happy_var_1 -> 
	case happyOut10 happy_x_3 of { happy_var_3 -> 
	happyIn9
		 (\p -> (happy_var_1 p) :&: (happy_var_3 p)
	)}}

happyReduce_12 = happySpecReduce_1  5# happyReduction_12
happyReduction_12 happy_x_1
	 =  case happyOut10 happy_x_1 of { happy_var_1 -> 
	happyIn9
		 (happy_var_1
	)}

happyReduce_13 = happySpecReduce_1  6# happyReduction_13
happyReduction_13 happy_x_1
	 =  case happyOutTok happy_x_1 of { (TokenBool happy_var_1) -> 
	happyIn10
		 (\p -> CBool happy_var_1
	)}

happyReduce_14 = happySpecReduce_2  6# happyReduction_14
happyReduction_14 happy_x_2
	happy_x_1
	 =  case happyOut10 happy_x_2 of { happy_var_2 -> 
	happyIn10
		 (\p -> Neg (happy_var_2 p)
	)}

happyReduce_15 = happyReduce 4# 6# happyReduction_15
happyReduction_15 (happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOutTok happy_x_1 of { (TokenID happy_var_1) -> 
	case happyOutTok happy_x_3 of { (TokenID happy_var_3) -> 
	happyIn10
		 (\(x,e) -> if happy_var_3 == x
                       then BFunCall happy_var_1 
	                   else if happy_var_3 == e && happy_var_1 == "train" 
                            then AP "(e.in%2 && e.out%2)"
                            else error ("unknown atomic predicate:" ++ happy_var_1)
	) `HappyStk` happyRest}}

happyReduce_16 = happyReduce 6# 6# happyReduction_16
happyReduction_16 (happy_x_6 `HappyStk`
	happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOutTok happy_x_1 of { (TokenID happy_var_1) -> 
	case happyOutTok happy_x_3 of { (TokenID happy_var_3) -> 
	case happyOutTok happy_x_5 of { (TokenInt happy_var_5) -> 
	happyIn10
		 (\(x,e) -> if happy_var_3 == e 
                    then if happy_var_1 == "from" then AP ("e.in==" ++ show happy_var_5) 
                 	 else if happy_var_1 == "to" then AP ("e.out==" ++ show happy_var_5) 
                              else error ("unknown atomic predicate:" ++ happy_var_1) 
                    else bot "apc"
	) `HappyStk` happyRest}}}

happyReduce_17 = happySpecReduce_3  6# happyReduction_17
happyReduction_17 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut8 happy_x_2 of { happy_var_2 -> 
	happyIn10
		 (happy_var_2
	)}

happyReduce_18 = happySpecReduce_1  6# happyReduction_18
happyReduction_18 happy_x_1
	 =  case happyOut11 happy_x_1 of { happy_var_1 -> 
	happyIn10
		 (happy_var_1
	)}

happyReduce_19 = happySpecReduce_3  7# happyReduction_19
happyReduction_19 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut12 happy_x_1 of { happy_var_1 -> 
	case happyOut12 happy_x_3 of { happy_var_3 -> 
	happyIn11
		 (\p -> equiv (happy_var_1 p) (happy_var_3 p)
	)}}

happyReduce_20 = happySpecReduce_3  7# happyReduction_20
happyReduction_20 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut12 happy_x_1 of { happy_var_1 -> 
	case happyOut12 happy_x_3 of { happy_var_3 -> 
	happyIn11
		 (\p -> lt (happy_var_1 p) (happy_var_3 p)
	)}}

happyReduce_21 = happySpecReduce_3  7# happyReduction_21
happyReduction_21 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut12 happy_x_1 of { happy_var_1 -> 
	case happyOut12 happy_x_3 of { happy_var_3 -> 
	happyIn11
		 (\p -> leq (happy_var_1 p) (happy_var_3 p)
	)}}

happyReduce_22 = happySpecReduce_3  7# happyReduction_22
happyReduction_22 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut12 happy_x_1 of { happy_var_1 -> 
	case happyOut12 happy_x_3 of { happy_var_3 -> 
	happyIn11
		 (\p -> gt (happy_var_1 p) (happy_var_3 p)
	)}}

happyReduce_23 = happySpecReduce_3  7# happyReduction_23
happyReduction_23 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut12 happy_x_1 of { happy_var_1 -> 
	case happyOut12 happy_x_3 of { happy_var_3 -> 
	happyIn11
		 (\p -> geq (happy_var_1 p) (happy_var_3 p)
	)}}

happyReduce_24 = happyReduce 6# 8# happyReduction_24
happyReduction_24 (happy_x_6 `HappyStk`
	happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut8 happy_x_2 of { happy_var_2 -> 
	case happyOut12 happy_x_4 of { happy_var_4 -> 
	case happyOut12 happy_x_6 of { happy_var_6 -> 
	happyIn12
		 (\p -> IfExp (happy_var_2 p) (happy_var_4 p) (happy_var_6 p)
	) `HappyStk` happyRest}}}

happyReduce_25 = happySpecReduce_1  8# happyReduction_25
happyReduction_25 happy_x_1
	 =  case happyOut13 happy_x_1 of { happy_var_1 -> 
	happyIn12
		 (happy_var_1
	)}

happyReduce_26 = happySpecReduce_3  9# happyReduction_26
happyReduction_26 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut13 happy_x_1 of { happy_var_1 -> 
	case happyOut14 happy_x_3 of { happy_var_3 -> 
	happyIn13
		 (\p -> addExp (happy_var_1 p) (happy_var_3 p)
	)}}

happyReduce_27 = happySpecReduce_1  9# happyReduction_27
happyReduction_27 happy_x_1
	 =  case happyOut14 happy_x_1 of { happy_var_1 -> 
	happyIn13
		 (happy_var_1
	)}

happyReduce_28 = happySpecReduce_3  10# happyReduction_28
happyReduction_28 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut14 happy_x_1 of { happy_var_1 -> 
	case happyOut15 happy_x_3 of { happy_var_3 -> 
	happyIn14
		 (\p -> multExp (happy_var_1 p) (happy_var_3 p)
	)}}

happyReduce_29 = happySpecReduce_1  10# happyReduction_29
happyReduction_29 happy_x_1
	 =  case happyOut15 happy_x_1 of { happy_var_1 -> 
	happyIn14
		 (happy_var_1
	)}

happyReduce_30 = happyReduce 4# 11# happyReduction_30
happyReduction_30 (happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOutTok happy_x_1 of { (TokenID happy_var_1) -> 
	case happyOutTok happy_x_3 of { (TokenID happy_var_3) -> 
	happyIn15
		 (\(x,e) -> if happy_var_3 == x 
                   then IFunCall happy_var_1 
                   else if happy_var_3 == e 
                        then if happy_var_1 == "w" 
                             then Weight "w"
                             else error "unknown weight function"
                        else bot "ifc"
	) `HappyStk` happyRest}}

happyReduce_31 = happySpecReduce_1  11# happyReduction_31
happyReduction_31 happy_x_1
	 =  case happyOutTok happy_x_1 of { (TokenInt happy_var_1) -> 
	happyIn15
		 (\p -> CInt happy_var_1
	)}

happyReduce_32 = happyReduce 6# 11# happyReduction_32
happyReduction_32 (happy_x_6 `HappyStk`
	happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut12 happy_x_3 of { happy_var_3 -> 
	case happyOut12 happy_x_5 of { happy_var_5 -> 
	happyIn15
		 (\p -> maxExp (happy_var_3 p) (happy_var_5 p)
	) `HappyStk` happyRest}}

happyReduce_33 = happyReduce 6# 11# happyReduction_33
happyReduction_33 (happy_x_6 `HappyStk`
	happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut12 happy_x_3 of { happy_var_3 -> 
	case happyOut12 happy_x_5 of { happy_var_5 -> 
	happyIn15
		 (\p -> minExp (happy_var_3 p) (happy_var_5 p)
	) `HappyStk` happyRest}}

happyReduce_34 = happySpecReduce_3  11# happyReduction_34
happyReduction_34 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut12 happy_x_2 of { happy_var_2 -> 
	happyIn15
		 (happy_var_2
	)}

happyNewToken action sts stk [] =
	happyDoAction 27# notHappyAtAll action sts stk []

happyNewToken action sts stk (tk:tks) =
	let cont i = happyDoAction i tk action sts stk tks in
	case tk of {
	TokenMinimize -> cont 1#;
	TokenST -> cont 2#;
	TokenWhere -> cont 3#;
	TokenID happy_dollar_dollar -> cont 4#;
	TokenBool happy_dollar_dollar -> cont 5#;
	TokenAnd -> cont 6#;
	TokenOr -> cont 7#;
	TokenNeg -> cont 8#;
	TokenInt happy_dollar_dollar -> cont 9#;
	TokenIf -> cont 10#;
	TokenThen -> cont 11#;
	TokenElse -> cont 12#;
	TokenMin -> cont 13#;
	TokenMax -> cont 14#;
	TokenEq -> cont 15#;
	TokenLeq -> cont 16#;
	TokenLe -> cont 17#;
	TokenGeq -> cont 18#;
	TokenGe -> cont 19#;
	TokenPlus -> cont 20#;
	TokenTimes -> cont 21#;
	TokenOB -> cont 22#;
	TokenCB -> cont 23#;
	TokenComma -> cont 24#;
	TokenSemicolon -> cont 25#;
	TokenDot -> cont 26#;
	_ -> happyError' (tk:tks)
	}

happyError_ tk tks = happyError' (tk:tks)

newtype HappyIdentity a = HappyIdentity a
happyIdentity = HappyIdentity
happyRunIdentity (HappyIdentity a) = a

instance Monad HappyIdentity where
    return = HappyIdentity
    (HappyIdentity p) >>= q = q p

happyThen :: () => HappyIdentity a -> (a -> HappyIdentity b) -> HappyIdentity b
happyThen = (>>=)
happyReturn :: () => a -> HappyIdentity a
happyReturn = (return)
happyThen1 m k tks = (>>=) m (\a -> k a tks)
happyReturn1 :: () => a -> b -> HappyIdentity a
happyReturn1 = \a tks -> (return) a
happyError' :: () => [Token] -> HappyIdentity a
happyError' = HappyIdentity . parseError

parse tks = happyRunIdentity happySomeParser where
  happySomeParser = happyThen (happyParse 0# tks) (\x -> happyReturn (happyOut4 x))

happySeq = happyDontSeq


main = do
         args <- getArgs 
         if args == []  
            then putStr "usage: ./OP <spec-file>"
		 else readFile (args!!0) >>= (generate . parse . lexer)

parseError ts = error ("Parse error: " ++ show ts)

bot = \s -> error ("parse error: "++s)

data Token = TokenMinimize
           | TokenST
           | TokenWhere
           | TokenID String
           | TokenBool Bool
           | TokenAnd
           | TokenOr
           | TokenNeg
           | TokenInt Int
           | TokenMin
           | TokenMax
           | TokenEq
           | TokenLeq
           | TokenLe 
           | TokenGeq 
           | TokenGe
           | TokenPlus
           | TokenTimes
           | TokenOB
           | TokenCB
           | TokenOBB
           | TokenCBB
           | TokenComma
           | TokenSemicolon
           | TokenDot
           | TokenIf
           | TokenThen
           | TokenElse
           deriving (Show,Eq)

lexer [] = []
lexer ('/':'/':cs) = skip1 cs
lexer ('/':'*':cs) = skip2 cs
lexer ('s':'.':'t':'.':cs) = TokenST : lexer cs
lexer ('&':'&':cs) = TokenAnd : lexer cs
lexer ('|':'|':cs) = TokenOr : lexer cs
lexer ('!':cs) = TokenNeg : lexer cs
lexer ('=':cs) = TokenEq : lexer cs
lexer ('<':'=':cs) = TokenLeq : lexer cs
lexer ('<':cs) = TokenLe : lexer cs
lexer ('>':'=':cs) = TokenGeq : lexer cs
lexer ('>':cs) = TokenGe : lexer cs
lexer ('+':cs) = TokenPlus : lexer cs
lexer ('*':cs) = TokenTimes : lexer cs
lexer ('(':cs) = TokenOB : lexer cs
lexer (')':cs) = TokenCB : lexer cs
lexer ('[':cs) = TokenOBB : lexer cs
lexer (']':cs) = TokenCBB : lexer cs
lexer (',':cs) = TokenComma : lexer cs
lexer (';':cs) = TokenSemicolon : lexer cs
lexer ('.':cs) = TokenDot : lexer cs
lexer (c:cs) | isSpace c = lexer cs
             | isAlpha c = lexAlpha (c:cs)
             | isDigit c = lexNum (c:cs)

lexAlpha cs =
   case span isIDChar cs of
      ("minimize",rest) -> TokenMinimize : lexer rest
      ("where",rest)  -> TokenWhere : lexer rest
      ("true",rest)  -> TokenBool True : lexer rest
      ("false",rest)  -> TokenBool False : lexer rest
      ("if",rest)  -> TokenIf : lexer rest
      ("min",rest)  -> TokenMin : lexer rest
      ("max",rest)  -> TokenMax : lexer rest
      ("then",rest)  -> TokenThen : lexer rest
      ("else",rest)  -> TokenElse : lexer rest
      (var,rest)   -> TokenID var : lexer rest

isIDChar c = isAlpha c || isDigit c || c == '_' || c == '-'

lexNum cs = TokenInt (read num) : lexer rest
      where (num,rest) = span isDigit cs

skip1 [] = []
skip1 ('\n':cs) = lexer cs
skip1 (_:cs) = skip1 cs
 
skip2 [] = []
skip2 ('*':'/':cs) = lexer cs
skip2 (_:cs) = skip2 cs
{-# LINE 1 "GenericTemplate.hs" #-}
{-# LINE 1 "<built-in>" #-}
{-# LINE 1 "<command line>" #-}
{-# LINE 1 "GenericTemplate.hs" #-}
-- Id: GenericTemplate.hs,v 1.26 2005/01/14 14:47:22 simonmar Exp 

{-# LINE 28 "GenericTemplate.hs" #-}


data Happy_IntList = HappyCons Int# Happy_IntList





{-# LINE 49 "GenericTemplate.hs" #-}

{-# LINE 59 "GenericTemplate.hs" #-}

{-# LINE 68 "GenericTemplate.hs" #-}

infixr 9 `HappyStk`
data HappyStk a = HappyStk a (HappyStk a)

-----------------------------------------------------------------------------
-- starting the parse

happyParse start_state = happyNewToken start_state notHappyAtAll notHappyAtAll

-----------------------------------------------------------------------------
-- Accepting the parse

-- If the current token is 0#, it means we've just accepted a partial
-- parse (a %partial parser).  We must ignore the saved token on the top of
-- the stack in this case.
happyAccept 0# tk st sts (_ `HappyStk` ans `HappyStk` _) =
	happyReturn1 ans
happyAccept j tk st sts (HappyStk ans _) = 
	(happyTcHack j (happyTcHack st)) (happyReturn1 ans)

-----------------------------------------------------------------------------
-- Arrays only: do the next action



happyDoAction i tk st
	= {- nothing -}


	  case action of
		0#		  -> {- nothing -}
				     happyFail i tk st
		-1# 	  -> {- nothing -}
				     happyAccept i tk st
		n | (n <# (0# :: Int#)) -> {- nothing -}

				     (happyReduceArr ! rule) i tk st
				     where rule = (I# ((negateInt# ((n +# (1# :: Int#))))))
		n		  -> {- nothing -}


				     happyShift new_state i tk st
				     where new_state = (n -# (1# :: Int#))
   where off    = indexShortOffAddr happyActOffsets st
	 off_i  = (off +# i)
	 check  = if (off_i >=# (0# :: Int#))
			then (indexShortOffAddr happyCheck off_i ==#  i)
			else False
 	 action | check     = indexShortOffAddr happyTable off_i
		| otherwise = indexShortOffAddr happyDefActions st

{-# LINE 127 "GenericTemplate.hs" #-}


indexShortOffAddr (HappyA# arr) off =
#if __GLASGOW_HASKELL__ > 500
	narrow16Int# i
#elif __GLASGOW_HASKELL__ == 500
	intToInt16# i
#else
	(i `iShiftL#` 16#) `iShiftRA#` 16#
#endif
  where
#if __GLASGOW_HASKELL__ >= 503
	i = word2Int# ((high `uncheckedShiftL#` 8#) `or#` low)
#else
	i = word2Int# ((high `shiftL#` 8#) `or#` low)
#endif
	high = int2Word# (ord# (indexCharOffAddr# arr (off' +# 1#)))
	low  = int2Word# (ord# (indexCharOffAddr# arr off'))
	off' = off *# 2#





data HappyAddr = HappyA# Addr#




-----------------------------------------------------------------------------
-- HappyState data type (not arrays)

{-# LINE 170 "GenericTemplate.hs" #-}

-----------------------------------------------------------------------------
-- Shifting a token

happyShift new_state 0# tk st sts stk@(x `HappyStk` _) =
     let i = (case unsafeCoerce# x of { (I# (i)) -> i }) in
--     trace "shifting the error token" $
     happyDoAction i tk new_state (HappyCons (st) (sts)) (stk)

happyShift new_state i tk st sts stk =
     happyNewToken new_state (HappyCons (st) (sts)) ((happyInTok (tk))`HappyStk`stk)

-- happyReduce is specialised for the common cases.

happySpecReduce_0 i fn 0# tk st sts stk
     = happyFail 0# tk st sts stk
happySpecReduce_0 nt fn j tk st@((action)) sts stk
     = happyGoto nt j tk st (HappyCons (st) (sts)) (fn `HappyStk` stk)

happySpecReduce_1 i fn 0# tk st sts stk
     = happyFail 0# tk st sts stk
happySpecReduce_1 nt fn j tk _ sts@((HappyCons (st@(action)) (_))) (v1`HappyStk`stk')
     = let r = fn v1 in
       happySeq r (happyGoto nt j tk st sts (r `HappyStk` stk'))

happySpecReduce_2 i fn 0# tk st sts stk
     = happyFail 0# tk st sts stk
happySpecReduce_2 nt fn j tk _ (HappyCons (_) (sts@((HappyCons (st@(action)) (_))))) (v1`HappyStk`v2`HappyStk`stk')
     = let r = fn v1 v2 in
       happySeq r (happyGoto nt j tk st sts (r `HappyStk` stk'))

happySpecReduce_3 i fn 0# tk st sts stk
     = happyFail 0# tk st sts stk
happySpecReduce_3 nt fn j tk _ (HappyCons (_) ((HappyCons (_) (sts@((HappyCons (st@(action)) (_))))))) (v1`HappyStk`v2`HappyStk`v3`HappyStk`stk')
     = let r = fn v1 v2 v3 in
       happySeq r (happyGoto nt j tk st sts (r `HappyStk` stk'))

happyReduce k i fn 0# tk st sts stk
     = happyFail 0# tk st sts stk
happyReduce k nt fn j tk st sts stk
     = case happyDrop (k -# (1# :: Int#)) sts of
	 sts1@((HappyCons (st1@(action)) (_))) ->
        	let r = fn stk in  -- it doesn't hurt to always seq here...
       		happyDoSeq r (happyGoto nt j tk st1 sts1 r)

happyMonadReduce k nt fn 0# tk st sts stk
     = happyFail 0# tk st sts stk
happyMonadReduce k nt fn j tk st sts stk =
        happyThen1 (fn stk tk) (\r -> happyGoto nt j tk st1 sts1 (r `HappyStk` drop_stk))
       where sts1@((HappyCons (st1@(action)) (_))) = happyDrop k (HappyCons (st) (sts))
             drop_stk = happyDropStk k stk

happyMonad2Reduce k nt fn 0# tk st sts stk
     = happyFail 0# tk st sts stk
happyMonad2Reduce k nt fn j tk st sts stk =
       happyThen1 (fn stk tk) (\r -> happyNewToken new_state sts1 (r `HappyStk` drop_stk))
       where sts1@((HappyCons (st1@(action)) (_))) = happyDrop k (HappyCons (st) (sts))
             drop_stk = happyDropStk k stk

             off    = indexShortOffAddr happyGotoOffsets st1
             off_i  = (off +# nt)
             new_state = indexShortOffAddr happyTable off_i




happyDrop 0# l = l
happyDrop n (HappyCons (_) (t)) = happyDrop (n -# (1# :: Int#)) t

happyDropStk 0# l = l
happyDropStk n (x `HappyStk` xs) = happyDropStk (n -# (1#::Int#)) xs

-----------------------------------------------------------------------------
-- Moving to a new state after a reduction


happyGoto nt j tk st = 
   {- nothing -}
   happyDoAction j tk new_state
   where off    = indexShortOffAddr happyGotoOffsets st
	 off_i  = (off +# nt)
 	 new_state = indexShortOffAddr happyTable off_i




-----------------------------------------------------------------------------
-- Error recovery (0# is the error token)

-- parse error if we are in recovery and we fail again
happyFail  0# tk old_st _ stk =
--	trace "failing" $ 
    	happyError_ tk

{-  We don't need state discarding for our restricted implementation of
    "error".  In fact, it can cause some bogus parses, so I've disabled it
    for now --SDM

-- discard a state
happyFail  0# tk old_st (HappyCons ((action)) (sts)) 
						(saved_tok `HappyStk` _ `HappyStk` stk) =
--	trace ("discarding state, depth " ++ show (length stk))  $
	happyDoAction 0# tk action sts ((saved_tok`HappyStk`stk))
-}

-- Enter error recovery: generate an error token,
--                       save the old token and carry on.
happyFail  i tk (action) sts stk =
--      trace "entering error recovery" $
	happyDoAction 0# tk action sts ( (unsafeCoerce# (I# (i))) `HappyStk` stk)

-- Internal happy errors:

notHappyAtAll = error "Internal Happy error\n"

-----------------------------------------------------------------------------
-- Hack to get the typechecker to accept our action functions


happyTcHack :: Int# -> a -> a
happyTcHack x y = y
{-# INLINE happyTcHack #-}


-----------------------------------------------------------------------------
-- Seq-ing.  If the --strict flag is given, then Happy emits 
--	happySeq = happyDoSeq
-- otherwise it emits
-- 	happySeq = happyDontSeq

happyDoSeq, happyDontSeq :: a -> b -> b
happyDoSeq   a b = a `seq` b
happyDontSeq a b = b

-----------------------------------------------------------------------------
-- Don't inline any functions from the template.  GHC has a nasty habit
-- of deciding to inline happyGoto everywhere, which increases the size of
-- the generated parser quite a bit.


{-# NOINLINE happyDoAction #-}
{-# NOINLINE happyTable #-}
{-# NOINLINE happyCheck #-}
{-# NOINLINE happyActOffsets #-}
{-# NOINLINE happyGotoOffsets #-}
{-# NOINLINE happyDefActions #-}

{-# NOINLINE happyShift #-}
{-# NOINLINE happySpecReduce_0 #-}
{-# NOINLINE happySpecReduce_1 #-}
{-# NOINLINE happySpecReduce_2 #-}
{-# NOINLINE happySpecReduce_3 #-}
{-# NOINLINE happyReduce #-}
{-# NOINLINE happyMonadReduce #-}
{-# NOINLINE happyGoto #-}
{-# NOINLINE happyFail #-}

-- end of Happy Template.
