/*
  Interface to use the programs.
  Note: It includes "val.cpp", which would be generated by the code generater.
*/

#include <iostream>
#include <fstream>
#include <sys/time.h>
#include <cstdlib>
using namespace std;

#ifdef DEBUG
#define __DEBUG(x) x
#else
#define __DEBUG(x) /* do nothing */
#endif

#include "node_edge.h"
#include "val.cpp" 
#include "path.cpp"
#include "graph.cpp"

int main( int argc, char* argv[]) {
  if (argc == 0) {
	cout << "usage: ./op.exe <graph-file>" << endl;
	return 0;
  }
  ifstream fin;
  fin.open( argv[1], ios::in );
  if (!fin.is_open()) {
	cout << "Cannot open file:" << argv[1] << endl;
	return -1;
  }
  
  graph g(fin);
  //  g.print();

  timeval st, et;
  gettimeofday(&st, NULL);
  g.search();
  gettimeofday(&et, NULL);
  cout << "computational time: " << ((et.tv_sec - st.tv_sec) * 1e6 + (et.tv_usec - st.tv_usec)) / 1000 << "msec" << endl;
  return 0;
}
