#include <vector>
#include <cassert>
using namespace std;

__DEBUG(int max_path_length = 0;)

struct path {
  val v;
  val prev;

  path() {};
  path(val v_, val p) : v(v_), prev(p) {};

  val state() const { return v; }
  node destination() const { return v.n; }
  int weight() const { return v.weight(); }

  void print(ostream &os) const;
  path extend(const edge &e);
};


inline path path::extend(const edge &e) {
  if (v.n == -1) v.n = e.in;
  return path(val(v, e), v);
}

inline bool operator<( const path &a, const path &b ) {
  return a.weight() < b.weight();
}


/*

void path::print(ostream &os) const {
  os << "[";
  for (vector<edge>::const_iterator it = p.begin(); it != p.end(); it++) {
    os << it->in << ",";
  }
  os << v.n << "]" << endl;
  os << v.weight() << endl;
}
*/
